import csv

from DataBaseAccess import *
from ExportWindow import *
from PyQt4 import QtCore
from PyQt4 import QtGui

class ExportController(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
		
        self.iW = Ui_ExportWindow()
        self.iW.setupUi(self)

        self.dBA = DataBaseManagement()
        self.connect(self.iW.pushButton, QtCore.SIGNAL('clicked()'), self.exportFile)
        self.show()
		
    def setQuizID(self, ID):
        self.quizID = ID
		
    def setQuizName(self, quizName):
        self.quizName = quizName
		
    def exportFile(self):
        quizIDList = self.dBA.getIDbyName(self.quizName)
        quizID = quizIDList[0]
        self.questions = self.dBA.getQuestions(quizID[0])
        #TODO remove empty lines between rows
        spamWriter = csv.writer(open(self.iW.lineEdit.text(), 'w'), delimiter=',', quotechar='"', quoting=csv.QUOTE_MINIMAL)
        for row in self.questions:
            #print (row)
            spamWriter.writerow([row[1], row[2]])
            self.close()

