import random

from DataBaseAccess import *
from PyQt4 import QtCore
from PyQt4 import QtGui
from quizWindow import *

class QuizController(QtGui.QWidget):
	
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        self.qW = Ui_quizWindow()
        self.qW.setupUi(self)
        self.dBA = DataBaseManagement()
		
        #TODO should be changed in UI file
        self.qW.pushButton.setText("Check")
        self.qW.label_2.setText("")
		
        #TODO connect show solution button
        self.connect(self.qW.pushButton, QtCore.SIGNAL('clicked()'), self.CheckAnswer)
        self.connect(self.qW.pushButton_3, QtCore.SIGNAL('clicked()'), self.quitQuiz)
		
        self.SecondQuestions = []
        self.intSecondTurn = 0
		
        self.show()
		
    def doQuiz(self, quizName):
		
        quizIDList = self.dBA.getIDbyName(quizName)
        quizID = quizIDList[0]
        self.questions = self.dBA.getQuestions(quizID[0])
        random.shuffle(self.questions)
        #returns empty
		
        if not self.questions:
            #change
            self.item = 0
            self.qW.label.setText("No Questions available")
        else:
            self.intI = 0
            for rows in self.questions:
                self.intI = self.intI + 1
                self.intMaxQuestions = self.intI
            self.intMaxQuestions = self.intMaxQuestions-1
		
            self.intI = 0
            self.item = self.questions[self.intI]
            self.qW.label.setText(self.item[1])
            #PQ.QuestionsLabel.setText(self.questions[0])
			
    def CheckAnswer(self):
        #Check if there is a question
        if not (self.item):
            return 0
        #Add Question asked
        self.dBA.increaseAsked(self.item[0])
        if self.intSecondTurn == 0:
            #Wenn der Text gleich ist wie in item[2] dann richtig
            if self.qW.plainTextEdit.text().lower() == self.item[2].lower():
                self.qW.label_2.setText("correct")
                self.dBA.increaseRightAnswered(self.item[0])
                #self.Statistics.QuestionRightAnswered(self.item[0])
            else:
                self.qW.label_2.setText("Wrong! Question: " + self.item[1] + " Answer: " + self.item[2])
                self.SecondQuestions.extend(self.item[0:3])
                #self.Statistics.QuestionWrongAnswered(self.item[0])
                #sonst falsch
                #Frage nach hinten
            #Naechste Frage ausgeben
            self.PrintNextQuestion()
        else:
			
            if self.qW.plainTextEdit.text() == self.SecondQuestions[2]:
                self.qW.label_2.setText("correct")
                self.dBA.increaseRightAnswered(self.SecondQuestions[0])
                del self.SecondQuestions[2]
                del self.SecondQuestions[1]
                del self.SecondQuestions[0]
                #self.Statistics.QuestionRightAnswered(self.item[0])
            else:
                self.qW.label_2.setText("Question: " + self.item[1] + " Answer: " + self.item[2])
                #sonst falsch
                self.SecondQuestions.append(self.SecondQuestions[0])
                self.SecondQuestions.append(self.SecondQuestions[1])
                self.SecondQuestions.append(self.SecondQuestions[2])
                #self.Statistics.QuestionWrongAnswered(self.item[0])
                #Frage nach hinten
            #Naechste Frage ausgeben
            self.PrintNextQuestion()
		
    def PrintNextQuestion(self):
        if self.intI < self.intMaxQuestions:
            self.intI = self.intI + 1
            self.qW.plainTextEdit.setText("")
            self.item = self.questions[self.intI]
            self.qW.label.setText(self.item[1])
        else:
            if not self.SecondQuestions:
                self.qW.label_2.setText("Quiz finished")
                self.qW.plainTextEdit.setText("")
                self.qW.label.setText("Quiz finished")
                #self.Statistics.exitQuizSuccess(selected.text());
                del self.item
                del self.questions
										
            else:
                self.intSecondTurn = 1
                self.qW.plainTextEdit.setText("")
                self.qW.label.setText(self.SecondQuestions[1])
				
    def quitQuiz(self):
        self.intSecondTurn = 0
        self.close()