from DataBaseAccess import *
from PyQt4 import QtCore
from PyQt4 import QtGui
from createWindow import *
from importController import *
from questionsController import *


class createQuizController(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
		
        self.cQW = Ui_createWindow()
        self.cQW.setupUi(self)
		
        self.dBA = DataBaseManagement()
		
        self.connect(self.cQW.pushButton_2, QtCore.SIGNAL('clicked()'), self.startImport)
        self.connect(self.cQW.pushButton, QtCore.SIGNAL('clicked()'), self.insertQuestions)
		
        self.show()
		
    def startImport(self):
        self.saveQuizName()
        self.iQC = importController()
        self.iQC.setQuizID(self.QuizID)
        self.close()
		
    def insertQuestions(self):
        self.saveQuizName()
        self.close()
        self.qC = questionController()
        self.qC.setQuizID(self.QuizID)

		
    def saveQuizName(self):
        self.QuizIDs = self.dBA.getQuizIDs()
        self.QuizID = 0
        for rows in self.QuizIDs:
            self.QuizID = self.QuizID + 1
	
        self.QuizID = self.QuizID + 1
        self.dBA.WriteNewQuizName(self.QuizID, self.cQW.lineEdit.text())
		