import csv

from DataBaseAccess import *
from PyQt4 import QtCore
from PyQt4 import QtGui
from importWindow import *

class importController(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
		
        self.iW = Ui_importWindow()
        self.iW.setupUi(self)
        self.dBA = DataBaseManagement()
        self.connect(self.iW.pushButton, QtCore.SIGNAL('clicked()'), self.importFile)

        self.show()
		
    def setQuizID(self, ID):
        self.quizID = ID
		
    def importFile(self):
        self.QuestionIDs = self.dBA.getQuestionIDs()
        self.questionID = 0
        for rows in self.QuestionIDs:
            self.questionID = self.questionID + 1

        csvReader = csv.reader(open(self.iW.lineEdit.text(), newline=''), delimiter=',', quotechar='|')
        for row in csvReader:
            #print (row)
            self.dBA.InsertData(self.questionID + 1, self.quizID, row[0], row[1])
            self.dBA.addQuestionToStats(self.questionID + 1)
            self.questionID = self.questionID + 1
            self.close()

