from DataBaseAccess import *
from PyQt4 import QtCore
from PyQt4 import QtGui
from questionsWindow import *

class questionController(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
		
        self.iQ = Ui_questionsWindow()
        self.iQ.setupUi(self)
		
        self.dBA = DataBaseManagement()
		
        self.connect(self.iQ.pushButton, QtCore.SIGNAL('clicked()'), self.insertData)
        self.connect(self.iQ.pushButton_2, QtCore.SIGNAL('clicked()'), self.closeWindow)
		
        self.show()
		
		
		
    def setQuizID(self, ID):
        self.quizID = ID
		
    def insertData(self):
        Data = [self.iQ.lineEdit.text(), self.iQ.lineEdit_2.text()]

        self.iQ.lineEdit.setText("")
        self.iQ.lineEdit_2.setText("")
        self.QuestionIDs = self.dBA.getQuestionIDs()
        self.QuestionIDs.sort()
        self.questionID = 0
        for rows in self.QuestionIDs:
            self.questionID = self.questionID + 1
        self.dBA.InsertData(self.questionID + 1, self.quizID, Data[0], Data[1])
        self.dBA.addQuestionToStats(self.questionID + 1)
		
    def closeWindow(self):
        self.close()
	